{{
TwiKeyboardDemo.spin - demo of TwiKeyboard.spin

TwiKeyboard.spin is a driver for communicating with PS2
TWI intelligent peripheral such as the TinyTwoWire module
and early GG_SDRAM modules.
}}

CON
   _clkmode  = xtal1 + pll16x
   _clkfreq  = 80_000_000

    TVPIN   = 20

    SCL     = 28
    SDA     = 29

OBJ

  kb : "TwiKeyboard"
  tv : "TV_Text_Half_Height"


VAR

  long maxrows
  long maxcols

PUB main | mx,my,mz,k

  maxrows := tv#MAXROWS-3   ' my display is not adjustable
  maxcols := tv#MAXCOLS     ' my display is not adjustable

' Start user display
  tv.start(TVPIN,tv#NTSC,tv#INTERLACE,maxcols,maxrows)

' Start TWI keyboard device
  kb.start(SCL,SDA)

  waitcnt(clkfreq/2+cnt)
  tv.str(string("TwiKeyboard test. ",$d))
  tv.str(string("Press any key ... ",$d))

  repeat

    k := kb.getkey
    if k > constant($80-1)
      special(k)
    else
      tv.out(k)


PUB special(k)
{{
Handle special things that are not handled by the keyboard driver COG
}}

  case k
    '      C0      Left Arrow
    $C0:
      tv.out(8)
    '      C1      Right Arrow
    $C1:
      tv.out($a)
      tv.out(tv.getColumn+1)
    '      C2      Up Arrow
    $C2:
      tv.out(8)
      tv.out($b)
      tv.out(tv.getRow-1)
    '      C3      Down Arrow
    $C3:
      tv.out(8)
      tv.out($b)
      tv.out(tv.getRow+1)
    '      C4      Home
    $C4:
      'tv.out(0)
      tv.out($a)
      tv.out(0)
      tv.out($b)
      tv.out(0)
    '      C5      End
    $C5:
      tv.out($a)
      tv.out(maxcols-1)
      tv.out($b)
      tv.out(maxrows-1)
    '      C6      Page Up
    $C6:  ' what to do ?
    '      C7      Page Down
    $C7:  ' what to do ?
    '      C8      Backspace
    $C8:
      tv.out(8)
      tv.out(" ")
      tv.out(8)
    '      C9      Delete
    $C8:
      tv.out(8)
    '      CA      Insert
    $CA:
    '      CB      Esc
    '      CC      Apps
    '      CD      Power
    '      CE      Sleep
    '      CF      Wakeup
    '
    '      D0..DB  F1..F12
    '      DC      Print Screen
    '      DD      Scroll Lock
    $DD:
    '      DE      Caps Lock
    $DE:
    '      DF      Num Lock
    $DF:
  
    ' unhandled
    other: tv.out(k)

